# Copyright (C) 2005  Network Applied Communication Laboratory Co., Ltd.
#
# This file is part of Rast.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA

require "tmpdir"

module TestUtility
  module_function

  def mkdtemp(prefix, mode = 0700)
    retry_count = 0
    begin
      dir = File.join(Dir.tmpdir, 
                      "#{prefix}-#{$$}.#{rand(10000)}")
      Dir.mkdir(dir, mode)
      return dir
    rescue Errno::EEXIST
      if retry_count < 3
        retry_count += 1
        retry
      else
        raise "can't create #{dir}"
      end
    end
  end

  def rm_rf(filename)
    count = 0
    begin
      FileUtils.rm_rf(filename)
    rescue Errno::ENOTEMPTY
      if count >= 3
        raise
      end
      count += 1
      retry
    end
  end
end
